<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of VersionInfo, a plugin for Dotclear 2.3
#
# Copyright (c) 2010-2011 AkhThoT 
#
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# -- END LICENSE BLOCK ------------------------------------

if (!defined('DC_CONTEXT_ADMIN')) { return; }

$DirPlugHere = 'http://akhthot.free.fr/blog/';

?>
<html>
<head>
	<?php echo dcPage::jsPageTabs($default_tab); ?>
	<title><?php echo 'VersionInfo v&deg;'.$vplug; ?></title>
</head>
<body>
<h2><?php echo $ico64.html::escapeHTML($core->blog->name); ?> &rsaquo; <?php echo 'VersionInfo v&deg;'.$vplug; ?></h2>

<?php if (!empty($msg)) echo '<p class="message">'.$msg.'</p>'; ?>

<?php if (!empty($err)) echo '<p class="error">'.$err.'</p>'; ?>

<div class="multi-part" id="config" title="<?php echo __('Configuration'); ?>">
<div id="VersionInfo_options">
	<form method="post" action="">
		<p>
		<?php echo 'url <strong>IMG</strong> '.__("for this site").' : <strong>'.$core->blog->url.'VersionInfo/Img/&lt;plugin&gt;/&lt;plugin&gt;.&lt;version&gt</strong>';?>
		<br />
		<?php echo 'url <strong>SON</strong> '.__("for this site").' : <strong>'.$core->blog->url.'VersionInfo/Son/&lt;plugin&gt;/&lt;plugin&gt;.&lt;version&gt</strong>';?>
		<br />
		<?php echo 'url <strong>ZIP</strong> '.__("for this site").' : <strong>'.$core->blog->url.'VersionInfo/Zip/&lt;plugin&gt;/&lt;plugin&gt;.&lt;version&gt</strong>';?>
		</p>
		<fieldset>
			<legend><?php echo $ico16.'&nbsp;'.__('General parameters'); ?></legend>
				<div class="two-cols">
				<div class="col">
				<p class="field">
					<?php echo form::checkbox('VersionInfo_Ok', 1, html::escapeHTML($core->VersionInfo_Params['Ok'])); ?>
					<label class=" classic" for="VersionInfo_Ok"> <?php echo __('Activation Plugin');?></label>
				</p>
				<p class="field">
					<?php echo form::field('VersionInfo_Folder', 40, 255, html::escapeHTML($core->VersionInfo_Params['Folder'])); ?>
					<label class=" classic" for="VersionInfo_Folder"> <?php echo __('Storage folder');?></label>
				</p>
				<p class="field">
					<?php echo form::field('VersionInfo_AdmURL', 40, 255, html::escapeHTML($core->VersionInfo_Params['AdmURL'])); ?>
					<label class=" classic" for="VersionInfo_AdmURL"> <?php echo __("admin access URL");?></label>
				</p>
				<p class="field">
					<?php echo form::checkbox('VersionInfo_Log', 1, html::escapeHTML($core->VersionInfo_Params['Log'])); ?>
					<label class=" classic" for="VersionInfo_Log"> <?php echo __("Access login");?></label>
				</p>
				<p class="field">
					<?php echo form::checkbox('VersionInfo_LastZip', 1, html::escapeHTML($core->VersionInfo_Params['LastZip'])); ?>
					<label class=" classic" for="VersionInfo_LastZip"> <?php echo __('Force last Zip');?></label>
				</p>
				</div>
				<div class="col">
				<p><?php echo __("Follow-up");?> <a href="http://akhthot.free.fr/blog/pages/VersionInfo"><?php echo $ico16;?>&nbsp;VersionInfo</a></p>
				<p><?php echo __("By default")." <strong>VersionInfo</strong> ".__("In the root of the public folder");?></p>
				<p><?php echo __("By default")." <strong>Admin</strong>, ".__("To change to avoid the curious");?></p>
				<p>&nbsp;</p>
				<p><?php echo __("This option assures you that the version of the Zip will always be the most recent");?></p>
				</div>
				</div>
		</fieldset>

		<fieldset>
			<legend><?php echo $ico16.'&nbsp;'.__("Administration Parameters"); ?></legend>
				<div class="two-cols">
				<div class="col">
				<p class="field">
					<?php echo form::checkbox('VersionInfo_DashBoardFavs', 1, html::escapeHTML($core->VersionInfo_Params['DashBoardFavs'])); ?>
					<label class=" classic" for="VersionInfo_DashBoardFavs"> <?php echo __("Icône Favoris");?></label>
				</p>
				<p class="field">
					<?php echo form::checkbox('VersionInfo_InfoVersion', 1, html::escapeHTML($core->VersionInfo_Params['InfoVersion'])); ?>
					<label class=" classic" for="VersionInfo_InfoVersion"> <?php echo __('Activation VersionInfo');?></label>
				</p>
				</div>
				<div class="col">
				<p><?php echo __("Icône proposée aux favoris");?></p>
				<p>
					<?php if ($core->VersionInfo_Params['InfoVersion']) echo '<a href="'.$DirPlugHere.'VersionInfo/Son/VersionInfo/VersionInfo.'.$vplug.'"><img src="'.$DirPlugHere.'VersionInfo/Img/VersionInfo/VersionInfo.'.$vplug.'" alt="VersionInfo '.__("Unavailable!").'" title="VersionInfo" /></a>';?>
				</p>
				</div>
				</div>
		</fieldset>

		<fieldset>
			<input type="submit" name="saveconfig" value="<?php echo __("Save this Configuration"); ?>" />
			<br /><br />
			<?php
			if (!$core->VersionInfo->TsTFolder($core->blog->public_path,$core->VersionInfo_Params['Folder'],''))
				echo '<input type="submit" name="VersionInfo_NewFolder" value="'.__("Create Folder").' '.$core->VersionInfo_Params['Folder'].'" />&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;';
			else if (!$core->VersionInfo->TsTFolderHT($core->blog->public_path,$core->VersionInfo_Params['Folder'],''))
				echo '<input type="submit" name="VersionInfo_ProtectFolder" value="'.__("Protect Folder").' '.$core->VersionInfo_Params['Folder'].'" />&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;&nbsp;';
			?>
			<input type="text" name="VersionInfo_NomPlugin" size="40" maxlength="200" />
			<input type="submit" name="VersionInfo_NewPlugin" value="<?php echo __("Create the Folder of this Plugin");?>" />
			<input type="hidden" name="p" value="VersionInfo" /><?php echo $core->formNonce(); ?>
		</fieldset>
		
		<fieldset>
			<legend><?php echo $ico16.'&nbsp;'.__('Presentation'); ?></legend>
				<div class="two-cols">
				<div class="col">
					<p>Le problème, pour les utilisateurs de vos plugins, suivre leurs évolutions et donc être au courant des nouvelles versions, corrigeant des bugs, voir plus grave corrigeant des failles de sécurité ! Jusqu'à présent, ils pouvaient penser à faire un tour de temps en temps sur le site de dépôt du plugin ou votre site, ou (lorsque cela sera à nouveau possible et si votre plugin est 'officiel') vérifier si des mises-à-jour sont disponibles directement dans l'admin avec le plugin adéquat.</p>
					<p>Je vous propose de remonter directement cette information sous la forme d'une simple image (accompagnée ou non d'un message sonore), dans la page d'administration de votre plugin. Seule obligation pour les utilisateurs aller faire un tour sur cette page d'administration, ce qui peut être gênant pour les plugins ne nécessitant pas de passer beaucoup de temps dans cette page, mais bon toute solution présente des inconvénients et cela doit rester non-intrusif et contrôlable. Deuxième obligation, cette fois-ci pour vous, s'astreindre à gérer ces images (et messages sonores éventuels) informant des mises-à-jour pour chaque nouvelle version que vous publiérez !</p>
					<p>Et puis, tant qu'à faire pourquoi ne pas essayer de suivre un peu l'utilisation de vos plugins en enregistrant les accès aux images (et éventuels messages sonores) ... et enfin pourquoi ne pas suivre le téléchargement des archives de vos plugins eux-même.</p>
					<p>Bien sur ce suivi n'a peut-être rien à faire dans votre blog, car il n'y a aucune partie publique et toutes ces informations ne concernent que vous, mais voilà vu que c'est en général sur un blog dotclear que vous présenté vos plugins et les mettez à disposition, ce n'est pas tout à fait idiot finalement LOL .</p>
				</div>
				<div class="col">
					<p>The problem, for the users of your plugins, to follow their evolutions and thus to know about new versions, correcting bugs, to see graver correcting faults of safety! Until now, they could think of making a tour from time to time on the site of deposit of the plugin or your site, or (when it will again be possible and if your plugin is 'official') to verify if stakes - in the day are available directly in the admin with the adequate plugin.</p>
					<p>I suggest you to put directly this information under the shape of a simple image (accompanied or not with a sound message), in the page of administration of your plugin. Only obligation for the users to go to make a tour on this page of administration, what can be annoying for plugins not requiring to spend a lot of time in this page, but well any solution presents inconveniences and it has to remain non-intrusive and controllable. The second obligation, this time for you, to force to manage these images (and possible sound messages) informing stakes - in the day for every new version that you will publish!</p>
					<p>And then, why not try to follow a little the use of your plugins by recording the accesses to the images (and possible sound messages) and finally why not to follow the download of the archives of your plugins.</p>
					<p>Indeed on this follow-up maybe has to make nothing in your blog, because there is no public part and all this information concerns only you, but here is seen that it is generally on the blog dotclear that you presented your plugins and give them, it is not completely stupid finally LOL.</p>
				</div>
				</div>
		</fieldset>

		<fieldset>
			<legend><?php echo $ico16.'&nbsp;'.__('Principle'); ?></legend>
				<div class="two-cols">
				<div class="col">
					<p>A chaque nouvelle version de votre plugin vous pouvez créer une image (et une annonce sonore) pour chacune de vos anciennes versions. Ce message va vous permettre d'informer les utilisateurs de la sortie d'une nouvelle version et de les inciter ou non suivant leur version actuelle à passer à la nouvelle.</p>
					<p>Pour ce faire dans la page d'administration vous pouvez placer un code du type : <br /><pre>&lt;img src="<?php echo $core->blog->url;?>VersionInfo/Img/&lt;plugin&gt;/&lt;plugin&gt;.&lt;version&gt" /&gt;</pre><br />Veillez bien à ce que vos numéros de version soit chronologique par un tri alphabétique.</p>
					<p>Pour suivre les téléchargements des archives Zip de vos plugins, tout liens vers ceux-ci seront automatiquement remplacés par un chemin particulier et ceci dans l'excerpt, le content et les attachments.</p>
					<p>Pour que tout ceci fonctionne il vous faut un dossier dans public et pour chaque plugin un sous-dossier à son nom et enfin à l'intérieur de ces sous-dossiers les images et les annonces sonores ainsi que les archives Zip. Les fichiers de comptage et de logs seront aussi stockés ici. Mais vous n'aurez même pas à utiliser un ftp pour le faire (sauf l'effacement de dossier ou fichier).</p>
					<p>A noter que si une demande d'image ou d'annonce sonore ne peut être réalisée du fait d'un mauvais numéro de version, le numéro de version sera transformée par <strong>UNKNOW</strong>. De même si le plugin n'existe pas le nom du plugin.version sera transformé par <strong>_UNKNOW.UNKNOW</strong>. Enfin si vous n'avez pas prévu des images l'image par défaut stockée dans le dossier du plugin sera utilisée.</p>
					<p><em>Bon si malgré toutes ces informations cela ne vous semble pas clair, allez jeter un oeil sur le code, vous êtes des <strong>sorciers</strong> après tout LOL</em></p>
				</div>
				<div class="col">
					<p>To every new version of your plugin you can create an image (and a sound announcement) for each of your ancient versions. This message is going to allow you to inform the users of the release of a new version and to incite them or not according to their current version to installed the new one.</p>
					<p>To do it in the page of administration you can place a code of the type: <br /><pre>&lt;img src="<?php echo $core->blog->url;?>VersionInfo/Img/&lt;plugin&gt;/&lt;plugin&gt;.&lt;version&gt" /&gt;</pre><br /> Watch, please, that your version numbers is chronological by an alphabetical sorting.</p>
					<p>To follow the downloads of archives Zip of your plugins, quite links towards these will automatically be replaced by a particular road and this in excerpt, content and attachments.</p>
					<p>So that all this work, you need a folder in public and for every plugin a sub-folder for its name and finally inside these sub-folders the images and the sound announcements as well as the Zip archives. The files of counting and logs will also be stored here. But you will not even have to use a ftp to make it (except the deletion of folder or file).</p>
					<p>To note that if a request of image or sound announcement cannot be realized because of a wrong number of version, the version number will be transformed by <strong>UNKNOW</strong>. Of even if the plugin does not exist the name of the plugin.version will be transformed by <strong>_UNKNOW.UNKNOW</strong>. Finally if you did not plan images the image by default stored in the folder of the plugin will be used.</p>
					<p><em>Well if in spite of all this information it does not seem to you clear, go to have a look on the code, you are <strong>wizards</strong> after all LOL</em></p>
				</div>
				</div>
		</fieldset>

	</form>
</div> 
</div>
<?php
	foreach ($core->VersionInfo->TabFolder as $Plug)
		echo '<a href="'.$p_url.'&amp;tab='.$Plug.'" class="multi-part" >'.$Plug.'</a>';
?>
</body>
</html>
