<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of VersionInfo, a plugin for Dotclear 2.3
#
# Copyright (c) 2010-2011 AkhThoT 
#
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# -- END LICENSE BLOCK ------------------------------------

if (!defined('DC_CONTEXT_ADMIN')) { return; }

if (!empty($_POST['VersionInfo_Protect']))
	{
	if (!$core->VersionInfo->FolderHT($core->blog->public_path,$core->VersionInfo_Params['Folder'],$default_tab))
		$err = __("The folder")." <strong>".$default_tab."</strong> ".__("was not able to be protected!");
	else
		$msg = __("The folder for this plugin")." <strong>".$default_tab."</strong> ".__("was protected!");
	}

if (!empty($_POST['VersionInfo_UpFile']))
	{
	$err = '';
	if ($_FILES['VersionInfo_File']['error'])
		{
		switch ($_FILES['VersionInfo_File']['error'])
			{
			case UPLOAD_ERR_INI_SIZE:
				$err = __("The file exceeds(irritates) the weight authorized by the directive upload_max_filesize of php.ini");
				break;
			case UPLOAD_ERR_FORM_SIZE:
				$err = __("The file exceeds(irritates) the weight authorized by the field MAX_FILE_SIZE if it was given");
				break;
			case UPLOAD_ERR_PARTIAL:
				$err = __("The file was upload only partially");
				break;
			case UPLOAD_ERR_NO_FILE:
				$err = "No file was upload";
				break;
			}
		}
	else
		{
		if (file_exists($core->blog->public_path.'/'.$core->VersionInfo_Params['Folder'].'/'.$default_tab.'/'.$_FILES['VersionInfo_File']['name']))
			$err = __("The file already exists");
		else if(!is_uploaded_file($_FILES['VersionInfo_File']['tmp_name']) )
			$err = __("The file is untraceable");
		else
			{
			if (!move_uploaded_file($_FILES['VersionInfo_File']['tmp_name'],$core->blog->public_path.'/'.$core->VersionInfo_Params['Folder'].'/'.$default_tab.'/'.$_FILES['VersionInfo_File']['name']))
				$err = "Impossible à déplacer";
			}
		}
	if ($err) $core->error->add(__("Problem during the import: ").$err);
	else $msg = __("Successful addition!");
	unset($err);
	unset($_POST['VersionInfo_UpFile']);
}

if (!empty($_POST['VersionInfo_Down']))
	{
	$file = $core->blog->public_path.'/'.$core->VersionInfo_Params['Folder'].'/'.$_POST['VersionInfo_SelFile'];
	
	header('Content-Type: '.files::getMimeType($file));
	header('Content-Disposition: attachment; filename="'.basename($file).'"');
	readfile($file);
	exit();
	}
?>

<html>
<head>
	<?php echo dcPage::jsPageTabs($default_tab); ?>
	<title><?php echo 'VersionInfo v&deg;'.$vplug; ?></title>
</head>
<body>
<h2><?php echo $ico64.html::escapeHTML($core->blog->name); ?> &rsaquo; <?php echo 'VersionInfo v&deg;'.$vplug; ?></h2>

<?php if (!empty($msg)) echo '<p class="message">'.$msg.'</p>'; ?>

<?php if (!empty($err)) echo '<p class="error">'.$err.'</p>'; ?>

<a href="<?php echo($p_url.'&amp;tab=config'); ?>" class="multi-part"><?php echo(__('Configuration')); ?></a>
<?php
	foreach ($core->VersionInfo->TabFolder as $Plug)
	{
		if ($default_tab == $Plug)
		{
			$core->VersionInfo->EnumFiles($core->blog->public_path,$core->VersionInfo_Params['Folder'],$Plug);
		?>

<div class="multi-part" id="<?php echo $Plug; ?>" title="<?php echo $Plug; ?>">
<div id="VersionInfo_options">
	<form enctype="multipart/form-data" method="post" action="">

<?php
	if (!empty($core->VersionInfo->TabZIP))
	{
?>
		<fieldset>
			<legend><?php echo $ico16.'&nbsp;'.__('Archives ZIP'); ?></legend>
<?php
		if (is_file($core->blog->public_path.'/'.$core->VersionInfo_Params['Folder'].'/'.$Plug.'/'.$Plug.'.cnt'))
		{
			$ZipV = unserialize(file_get_contents($core->blog->public_path.'/'.$core->VersionInfo_Params['Folder'].'/'.$Plug.'/'.$Plug.'.cnt'));
		}
		foreach ($core->VersionInfo->TabZIP as $f)
		{
			$Cnt = '(0) ';
			if (isset($ZipV[substr($f,strpos($f,'.')+1)]))
				$Cnt = '('.$ZipV[substr($f,strpos($f,'.')+1)].') ';
			if (!isset($_POST['VersionInfo_ZIP_'.str_replace('.','_',$f)]))
				echo '<input type="submit" name="VersionInfo_ZIP_'.$f.'" value="'.$Cnt.$f.'" />&nbsp;&nbsp;';
			else
			{
				$SelFile = $f.'.zip';
				echo '<strong>&nbsp;&nbsp;'.$f.'&nbsp;&nbsp;&nbsp;&nbsp;</strong>';
			}
		}
?>
		</fieldset>
<?php
	}
	if (!empty($core->VersionInfo->TabIMG))
	{
?>
		<fieldset>
			<legend><?php echo $ico16.'&nbsp;'.__('Images PNG'); ?></legend>
			<p>
<?php
		foreach ($core->VersionInfo->TabIMG as $f)
			echo '<img style="vertical-align: middle;" src="'.$core->blog->url.'VersionInfo/'.$core->VersionInfo_Params['AdmURL'].'/'.$Plug.'/'.$f.'.png" title="'.$f.'" />';
?>
			</p>
		</fieldset>
<?php
	}
	if (!empty($core->VersionInfo->TabSON))
	{
?>
		<fieldset>
			<legend><?php echo $ico16.'&nbsp;'.__('Sound announcements MP3'); ?></legend>
			<p>
<?php			
		foreach ($core->VersionInfo->TabSON as $f)
			if (!isset($_POST['VersionInfo_SON_'.str_replace('.','_',$f)]))
				echo '<input type="submit" name="VersionInfo_SON_'.$f.'" value="'.$f.'" />&nbsp;&nbsp;';
			else
			{
				$SelFile = $f.'.mp3';
				echo '<strong>&nbsp;&nbsp;'.$f.'&nbsp;&nbsp;&nbsp;&nbsp;</strong>';
			}
?>
			</p>
		</fieldset>
<?php
	}
	if (!empty($core->VersionInfo->TabLGS))
	{
?>
		<fieldset>
			<legend><?php echo $ico16.'&nbsp;'.__('Logs LGS'); ?></legend>
<?php
		foreach ($core->VersionInfo->TabLGS as $f)
			if (!isset($_POST['VersionInfo_LGS_'.str_replace('.','_',$f)]))
				echo '<input type="submit" name="VersionInfo_LGS_'.$f.'" value="'.$f.'" />&nbsp;&nbsp;';
			else
			{
				$SelFile = $f.'.lgs';
				$ViewFile = $SelFile;
				echo '<strong>&nbsp;&nbsp;'.$f.'&nbsp;&nbsp;&nbsp;&nbsp;</strong>';
			}
?>
		</fieldset>
<?php
	}
?>
		<fieldset>
			<p>
<?php
	if (!$core->VersionInfo->TsTFolderHT($core->blog->public_path,$core->VersionInfo_Params['Folder'],$Plug))
	{
?>
			<input type="submit" name="VersionInfo_Protect" value="<?php echo __('Protect this Folder').' : '.$Plug; ?>" />
			&nbsp;&nbsp;-&nbsp;&nbsp;
<?php
	}
	if (!empty($SelFile))
	{
?>
			<input type="hidden" name="VersionInfo_SelFile" value="<?php echo $Plug.'/'.$SelFile;?>" />
			<input type="submit" name="VersionInfo_Down" value="<?php echo __('Get back the file').' : '.$SelFile; ?>" />
			&nbsp;&nbsp;-&nbsp;&nbsp;
<?php
	}
?>
			<input type="hidden" name="MAX_FILE_SIZE" value="2000000" />
			<input type="file" name="VersionInfo_File" />
			<input type="submit" name="VersionInfo_UpFile" value="<?php echo __('Add a File'); ?>" />
			</p>
		</fieldset>

<?php
	if (isset($ViewFile) and is_file($core->blog->public_path.'/'.$core->VersionInfo_Params['Folder'].'/'.$Plug.'/'.$ViewFile))
	{
		$Lines = file($core->blog->public_path.'/'.$core->VersionInfo_Params['Folder'].'/'.$Plug.'/'.$ViewFile);
	?>
		<fieldset>
			<legend><?php echo $ico16.'&nbsp;'.__('Contents of the file: ').$ViewFile; ?></legend>

			<style>table * {text-align:center;}</style>
			<table border="1">
				<tr>
					<th>Status</th>
					<th>Plugin</th>
					<th>Version</th>
					<th>Date</th>
					<th>IP</th>
					<th>REFERER</th>
					<th>URL</th>
				</tr>
<?php 
	foreach ($Lines as $Log)
	{
		$Lg = explode("\t",trim($Log));
	
		if ($Lg[0] == 'UnKnow Version')
				echo '<tr style="background-color:#cccccc;">';
		else
				echo '<tr>';
				
					echo '<td>'.$Lg[0].'</td>';
					echo '<td>'.$Lg[1].'</td>';
					echo '<td>'.$Lg[2].'</td>';
					echo '<td>'.$Lg[3].'</td>';
					if ($Lg[4] == '') echo '<td style="background-color:#e2dfca;">-</td>'; else echo '<td>'.$Lg[4].'</td>';
					if ($Lg[5] == '') echo '<td style="background-color:#e2dfca;">-</td>'; else echo '<td>'.$Lg[5].'</td>';
					if ($Lg[6] == '') echo '<td style="background-color:#e2dfca;">-</td>'; else echo '<td>'.$Lg[6].'</td>';

				echo '</tr>';
	}
	?>
			</table>
		</fieldset>
<?php
	}
	?>
		<input type="hidden" name="p" value="VersionInfo" /><?php echo $core->formNonce(); ?>
	</form>
</div> 
</div>

<?php
		}
		else
			echo '<a href="'.$p_url.'&amp;tab='.$Plug.'" class="multi-part" >'.$Plug.'</a>';
	}
?>
</body>
</html>
