<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of VersionInfo, a plugin for Dotclear 2.3
#
# Copyright (c) 2010-2011 AkhThoT
#
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# -- END LICENSE BLOCK ------------------------------------

if (!defined('DC_CONTEXT_ADMIN')) { return; }

$_menu['Plugins']->addItem(__('VersionInfo'),
		'plugin.php?p=VersionInfo','index.php?pf=VersionInfo/img-admin/VersionInfo-16x16.png',
		preg_match('/plugin.php\?p=VersionInfo(&.*)?$/',$_SERVER['REQUEST_URI']),
		$core->auth->check('admin',$core->blog->id));

if($core->VersionInfo_Params['DashBoardFavs'])
	$core->addBehavior('adminDashboardFavs',array('VersionInfo','adminDashboardFavs'));
$core->addBehavior('adminDashboardFavsIcon',array('VersionInfo','adminDashboardFavsIcon'));

$core->VersionInfo = new VersionInfo();

class VersionInfo
	{
	public static function adminDashboardFavs($core,$favs)
		{
		$favs['VersionInfo'] = new ArrayObject(array(
			'VersionInfo',
			'VersionInfo',
			'plugin.php?p=VersionInfo',
			'index.php?pf=VersionInfo/img-admin/VersionInfo-16x16.png',
			'index.php?pf=VersionInfo/img-admin/VersionInfo-64x64.png',
			null,
			null,
			null));
		}
	
	public static function adminDashboardFavsIcon($core,$name,$icon)	
		{
		if($name=='VersionInfo')
			{
			$icon[0] = 'VersionInfo';
			$icon[1] = 'plugin.php?p=VersionInfo';
			if($core->VersionInfo_Params['Ok'])
				$icon[2] = 'index.php?pf=VersionInfo/img-admin/VersionInfo-64x64-Ok.png';
			else
				$icon[2] = 'index.php?pf=VersionInfo/img-admin/VersionInfo-64x64-No.png';
			}
		}
	#--------------------------
# Enum Folders
	#--------------------------
	function EnumFolders($url,$Folder)
		{
		$this->TabFolder = array();
		
		if(is_dir($url.'/'.$Folder))
			{
			$HDir = opendir($url.'/'.$Folder);
			while (false !== ($Dir = readdir($HDir)))
				{
				if (is_dir($url.'/'.$Folder.'/'.$Dir) and $Dir != '.' and $Dir != '..')
					$this->TabFolder[strtolower($Dir)] = $Dir;
				}
			closedir($HDir);

			ksort($this->TabFolder);
			}
		}
	#--------------------------
# Enum Files
	#--------------------------
	function EnumFiles($url,$Folder,$Plugin)
		{
		$this->TabZIP = array();
		$this->TabIMG = array();
		$this->TabSON = array();
		$this->TabLGS = array();
		
		$HDir = opendir($url.'/'.$Folder.'/'.$Plugin.'/');
		while (false !== ($File = readdir($HDir)))
			{
			if (is_file($url.'/'.$Folder.'/'.$Plugin.'/'.$File))
				{
				switch (strtolower(substr($File,strlen($File)-4)))
					{
					case '.zip':
						$this->TabZIP[] = substr($File,0,strlen($File)-4);
						break;
					case '.png':
						$this->TabIMG[] = substr($File,0,strlen($File)-4);
						break;
					case '.mp3':
						$this->TabSON[] = substr($File,0,strlen($File)-4);
						break;
					case '.lgs':
						$this->TabLGS[] = substr($File,0,strpos($File,'.'));
						break;
					}
				}
			}
		closedir($HDir);

		asort($this->TabZIP);
		asort($this->TabIMG);
		asort($this->TabSON);
		asort($this->TabLGS);
		}
	#--------------------------
# TsT Existance Folder
	#--------------------------
	function TsTFolder($url,$Folder,$Nom)
		{
		if ($Folder != '.') $Folder .= '/'; else $Folder = '';
		if (!file_exists($url.'/'.$Folder.$Nom)) return false;
		return is_dir($url.'/'.$Folder.$Nom);
		}
	#--------------------------
# Cration Folder
	#--------------------------
	function CreateFolder($url,$Folder,$Nom)
		{
		if ($Folder != '.') $Folder .= '/'; else $Folder = '';
		return mkdir($url.'/'.$Folder.$Nom);
		}
	#--------------------------
# TsT Protection Folder
	#--------------------------
	function TsTFolderHT($url,$Folder,$Nom)
		{
		if (!self::TsTFolder($url,$Folder,$Nom)) return false;
		if ($Folder != '.') $Folder .= '/'; else $Folder = '';
		if (!file_exists($url.'/'.$Folder.$Nom.'/.htaccess')) return false;

		$Handle = fopen($url.'/'.$Folder.$Nom.'/.htaccess','r');
		$FirstLine = strtolower(trim(fgets($Handle)));
		fclose($Handle);

		if ($FirstLine == 'deny from all') return true;
		
		return false;
		}
	#--------------------------
# Protection Folder
	#--------------------------
	function FolderHT($url,$Folder,$Nom)
		{
		if (!self::TsTFolder($url,$Folder,$Nom)) return false;
		if (self::TsTFolderHT($url,$Folder,$Nom)) return false;

		if ($Folder != '.') $Folder .= '/'; else $Folder = '';

		$Lines = file_get_contents($url.'/'.$Folder.$Nom.'/.htaccess');
		
		$Handle = fopen($url.'/'.$Folder.$Nom.'/.htaccess','w');
		fwrite($Handle,"Deny from all\n".$Lines);
		fclose($Handle);
		
		return self::TsTFolderHT($url,$Folder,$Nom);
		}
	}
?>