<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of VersionInfo, a plugin for Dotclear 2.3
#
# Copyright (c) 2010-2011 AkhThoT 
#
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# -- END LICENSE BLOCK ------------------------------------

if (!defined('DC_CONTEXT_ADMIN')) { return; }

# Test des versions
$m_version = $core->plugins->moduleInfo('VersionInfo','version');
$i_version = $core->getVersion('VersionInfo');
if (version_compare($i_version,$m_version,'>=')) {
	return;
}

# si on veut pas craser les paramtres
$newParams = array(
	'Ok' => false,
	'DashBoardFavs' => false,
	'InfoVersion' => false,
	'Folder' => 'VersionInfo',
	'AdmURL' => 'Admin',
	'LastZip' => false,
	'Log' => false
	);

if (!is_null($core->blog->settings->VersionInfo))
	{
	if (!is_null($core->blog->settings->VersionInfo->sVersionInfo_Ok))
		$newParams['Ok'] = $core->blog->settings->VersionInfo->sVersionInfo_Ok;
	if (!is_null($core->blog->settings->VersionInfo->sVersionInfo_InfoVersion))
		$newParams['InfoVersion'] = $core->blog->settings->VersionInfo->sVersionInfo_InfoVersion;
	if (!is_null($core->blog->settings->VersionInfo->sVersionInfo_Folder))
		$newParams['Folder'] = $core->blog->settings->VersionInfo->sVersionInfo_Folder;
	if (!is_null($core->blog->settings->VersionInfo->sVersionInfo_AdmURL))
		$newParams['AdmURL'] = $core->blog->settings->VersionInfo->sVersionInfo_AdmURL;
	if (!is_null($core->blog->settings->VersionInfo->sVersionInfo_LastZip))
		$newParams['LastZip'] = $core->blog->settings->VersionInfo->sVersionInfo_LastZip;
	if (!is_null($core->blog->settings->VersionInfo->sVersionInfo_Log))
		$newParams['Log'] = $core->blog->settings->VersionInfo->sVersionInfo_Log;
	
	if (!is_null($core->blog->settings->VersionInfo->VersionInfo_Params))
		{
		$oldParams = unserialize($core->blog->settings->
			VersionInfo->VersionInfo_Params);
	
		foreach($oldParams as $Key => $Val)
			$newParams[$Key] = $Val;
		}
	}

# on tente de crer les paramtres
try
	{
	$core->blog->settings = new dcSettings($core,null);
	$core->blog->settings->addNameSpace('VersionInfo');
	$core->blog->settings->VersionInfo->put('VersionInfo_Params',
		serialize($newParams),'string');
	$core->setVersion('VersionInfo',$m_version);
	return true;
	}
catch (Exception $e)
	{
	$core->error->add($e->getMessage());
	return;
	}
?>