<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of VersionInfo, a plugin for Dotclear 2.3
#
# Copyright (c) 2010-2011 AkhThoT
#
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# -- END LICENSE BLOCK ------------------------------------

if (!defined('DC_RC_PATH')) { return; }

$core->url->register('VersionInfo','VersionInfo','^VersionInfo(?:/(.+))?$',array('BehaviorsVersionInfo','VersionInfo'));
if($core->VersionInfo_Params['Ok'])
	$core->addBehavior('publicBeforeContentFilter',array('BehaviorsVersionInfo','publicBeforeContentFilter'));

class BehaviorsVersionInfo extends dcUrlHandlers
	{
	#--------------------------
# transformer les urls VersionInfo en query string
	#--------------------------
	public static function publicBeforeContentFilter ($core,$tag,$args)
		{
		if ($tag == "AttachmentURL" or $tag == "EntryContent" or $tag == "EntryExcerpt")
			{
			$args[0] = str_ireplace($core->media->root_url.$core->VersionInfo_Params['Folder'],
				$core->blog->url.'VersionInfo/Zip',$args[0]);
			$args[0] = str_ireplace('"'.$core->blog->settings->public_url.'/'.$core->VersionInfo_Params['Folder'],
				'"'.$core->blog->url.'VersionInfo/Zip',$args[0]);
			}
		}
	#--------------------------
# url VersionInfo
	#--------------------------
	public static function VersionInfo($args)
		{
		global $core;

		$vUrl = $args;
		if($args[0]=="\\")
			$vUrl = substr($args,1);

		$Len = strlen($core->VersionInfo_Params['AdmURL'])+1;

		# Accs  partir de l'admin
		if (substr($vUrl,0,$Len) == $core->VersionInfo_Params['AdmURL'].'/')
			{
			$file = $core->media->root.'/'.$core->VersionInfo_Params['Folder'].'/'.substr($vUrl,$Len);

			header('Content-Type: '.files::getMimeType($file));
			header('Content-Disposition: filename="'.basename($file).'"');
			readfile($file);
			exit();
			}
		
		if (!$core->VersionInfo_Params['Ok']) return;

		$status = 'Ok';

		switch (strtolower(substr($vUrl,0,4)))
			{
			case 'zip/':
				$deb=4;
				$ext = '.zip';
				$status = 'Zip';
				break;
			case 'img/':
				$deb=4;
				$ext = '.png';
				$status = 'Img';
				break;
			case 'son/':
				$deb=4;
				$ext = '.mp3';
				$status = 'Son';
				break;
			default:
				$deb=0;
				$ext = '.png';
				$status = 'Err';
			}

		$fullplug = substr($vUrl,$deb,strpos($vUrl,'.')-$deb);
		$plug = substr($fullplug,0,strpos($fullplug,'/'));
		$version = substr($vUrl,strpos($vUrl,'.')+1);
		if (substr($version,-4) == $ext) $version = substr($version,0,-4);
		
		$FolderPlug = $core->media->root.'/'.$core->VersionInfo_Params['Folder'].'/'.$plug.'/';

		if (!is_dir($FolderPlug))
			{
			$status = 'UnKnow Plugins';
			$plug = '_UnKnow';
			$FolderPlug = $core->media->root.'/'.$core->VersionInfo_Params['Folder'].'/'.$plug.'/';
			}

		$FileLGS = $FolderPlug.date('Y-m-W').'.lgs';

		$lastOne = $version;

		$ZipV = array();
		if (is_file($FolderPlug.$plug.'.cnt'))
			$ZipV = unserialize(file_get_contents($FolderPlug.$plug.'.cnt'));
			
		$HDir = opendir($FolderPlug);
		while (false !== ($ZipFile = readdir($HDir)))
			{
			if (is_file($FolderPlug.'/'.$ZipFile) and strtolower(substr($ZipFile,strlen($ZipFile)-4)) == '.zip')
				{
				$ZipVersion = substr(substr($ZipFile,strpos($ZipFile,'.')+1),0,-4);;
				if(!isset($ZipV[$ZipVersion])) $ZipV[$ZipVersion] = 0;
				}
			}
		closedir($HDir);

		krsort($ZipV);
		foreach ($ZipV as $k => $v)
			{
			if (is_file($FolderPlug.$plug.'.'.$k.'.zip'))
				{
				$lastOne = $k;
				break;
				}
			}

		if ($status == 'Zip')
			{
			if($core->VersionInfo_Params['LastZip'])
				$version = $lastOne;

			if (is_File($FolderPlug.$plug.'.'.$version.$ext))
				{
				if (isset($ZipV[$version]))
					$ZipV[$version]++;
				else
					$ZipV[$version] = 1;

				$h = fopen($FolderPlug.$plug.'.cnt','w');
				fwrite($h,serialize($ZipV));
				fclose($h);
				}
			}
		else
			{
			if($version != $lastOne)
				$version = $lastOne.'-New';
			}

		$File = $FolderPlug.$plug.'.'.$version.$ext;
		
		if (!is_file($File))
			{
			$status = 'UnKnow Version';
			$version = 'UnKnow';
			$File = $FolderPlug.$plug.'.'.$version.$ext;
			}

		if ($core->VersionInfo_Params['Log'])
			{
			$lg = fopen($FileLGS,'a');
			fwrite($lg,$status);
			fwrite($lg,"\t".$plug);
			fwrite($lg,"\t".$version);
			fwrite($lg,"\t".date('D\,\ d\/m\/Y\ H\:i\:s'));
			if(isset($_SERVER['REMOTE_ADDR'])) fwrite($lg,"\t".$_SERVER['REMOTE_ADDR']); else fwrite($lg,"\t");
			if(isset($_SERVER['HTTP_REFERER'])) fwrite($lg,"\t".$_SERVER['HTTP_REFERER']); else fwrite($lg,"\t");
			if(isset($_SERVER['REQUEST_URI'])) fwrite($lg,"\t".$_SERVER['REQUEST_URI']); else fwrite($lg,"\t");
			fwrite($lg,"\n");
			fclose($lg);
			}

		if (!is_File($File))
			{
			if ($ext == '.zip') $ext = '.png';
			$PlugsDirs = array_reverse(explode(PATH_SEPARATOR,DC_PLUGINS_ROOT));
			foreach ($PlugsDirs as $p)
				{
				$File = $p.'/VersionInfo/err-admin/erreur'.$ext;
				if (is_File($File)) break;
				}
			unset($PlugsDirs);
			}

		header('Content-Type: '.files::getMimeType($File));
		header('Content-Disposition: filename="'.basename($File).'"');
		readfile($File);
		exit();
		}
	#--------------------------
# Debug IT !
	#--------------------------
	function DebugIt($s){$h=fopen('c:\DebugIt.log','a');fwrite($h,strftime("\n%d/%m/%Y-%H:%M:%S\t").$s);fclose($h);}
	}
?>